#include <stdio.h>
#include <stdlib.h>
#include <string.h>

struct stajaliste
{
	char *naziv;
	int broj;
	struct stajaliste *sledece;
};

#define novost(x) x=(struct stajaliste*)malloc(sizeof(struct stajaliste))

void dodajst(struct stajaliste **p, int br, char *ime)
{
	struct stajaliste *pom,*temp;
	novost(temp);
	temp->broj=br;
	temp->naziv=(char*)malloc(strlen(ime)+1);
	strcpy(temp->naziv,ime);
	temp->sledece=NULL;
	if((*p)==NULL) {(*p)=temp; (*p)->sledece=(*p); }
	else {
		pom=(*p);
		while(pom->sledece!=(*p)) pom=pom->sledece;
		pom->sledece=temp;
		temp->sledece=(*p);
	}
}

void ispis(struct stajaliste *p)
{
	struct stajaliste *pom;
	pom=p;
	do
	{
		printf("%s\t%d\n",pom->naziv,pom->broj);
		pom=pom->sledece;
	}while(pom!=p);
}

void obrni(struct stajaliste *p)
{
	int ulaz,izlaz;
	struct stajaliste *pom1,*pom2;
	pom1=p;
	pom2=NULL;
	while(p!=p->sledece)
	{
	scanf("%d",&ulaz);
	scanf("%d",&izlaz);
	if((ulaz==0) && (izlaz==0))
	{
		if(pom1==p)
		{
			pom2=pom1;
			while(pom2->sledece!=pom1) pom2=pom2->sledece;
			pom2->sledece=pom1->sledece;
			p=pom1->sledece;
			free(pom1);
		}
		else {
			pom2=pom1;
			while(pom2->sledece!=pom1) pom2=pom2->sledece;
			pom2->sledece=pom1->sledece;
			free(pom1);
		}
	}
	else 
	{
		if((pom1->broj+ulaz-izlaz)<0) pom1->broj=0;
		else pom1->broj=pom1->broj+ulaz-izlaz;
	}
	pom1=pom1->sledece;
	if(pom1==p) ispis(p);
}
}
	
	
int main(void)
{
	struct stajaliste *p;
	int ul,iz,n,i,z;
	char ime[100];
	p=NULL;
	z=0;
	scanf("%d",&n);
	for(i=0;i<n;i++)
	{
		scanf("%s",&ime);
		scanf("%d",&ul);
		scanf("%d",&iz);
		z+=ul;
		z-=iz;
		if(z<0) z=0;
		dodajst(&p,z,ime);
	}
	ispis(p);
	obrni(p);
	return 0;
}
