#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct drvo{
	char ime[30];
	float velicina;
	char  ext[10];
	struct drvo *desni, *levi;
}drvo;

drvo *dodaj(drvo *p, char ime[], float size, char ext[])
{
	drvo *novi, *trenutni, *pom;
	
	//printf("%s\n",ime);
	novi=(drvo*)malloc(sizeof(drvo));
	strcpy(novi->ime,ime);
	strcpy(novi->ext,ext);
	novi->velicina=size;
	novi->levi=NULL;
	novi->desni=NULL;
	//printf("%s21\n",ime);
	if(p==NULL)
	{
		//printf("%s2222\n",ime);
		p=novi;
	}
	else
	{   
		trenutni=p;
		while(trenutni!=NULL)
		{
			pom=trenutni;
			if(novi->velicina>=trenutni->velicina)
			   trenutni=trenutni->desni;
			else
			   trenutni=trenutni->levi;
		}
		if(novi->velicina>=pom->velicina)
		  pom->desni=novi;
		else
		  pom->levi=novi;
	  }

	  return p;
  }	   

drvo *Formiraj(int n)
{
	int i;
	drvo *p=NULL;
	float size;
	char ime[30],ext[10];
	
	for(i=0;i<n;i++)
	{
		scanf("%s",ime);
		scanf("%f",&size);
		scanf("%s",ext);
		//printf("%s\n",ime);
		
		p=dodaj(p,ime,size,ext);
	}
	return p;
}

void Ispis(drvo *p)
{
	if(p!=NULL)
	{
		Ispis(p->desni);
		printf("%s.%s   %f\n",p->ime,p->ext,p->velicina); 
        Ispis(p->levi);
	}

	
}

void KreirajNovo(drvo  **q,drvo *p, char ext[], float size)
{
	if(p!=NULL)
	{
		if(size<p->velicina)
		{
			if(strcmp(p->ext,ext)==0)
			  *q=dodaj(*q, p->ime,p->velicina,p->ext);
			KreirajNovo(q,p->levi,ext,size);
			KreirajNovo(q,p->desni,ext,size);
		}
		else
		   KreirajNovo(q,p->desni,ext,size);
	   }
   }
			
		
		

int main ()
{   
	drvo *p=NULL;
	drvo *q=NULL;
	int n;
	float s;
	char ext[20];
	printf("Unesite broj n:\n");
	scanf("%d",&n);
	p=Formiraj(n);
	printf("Unesite ekstenziju fajla i minimalnu velicinu\n");
	scanf("%s",ext);
	scanf("%f",&s);
	KreirajNovo(&q,p,ext,s);
	Ispis(p);
	printf("Novokreirano stablo q ima izgled\n");
	Ispis(q);
	return 0;
}
