#include <string.h>
#include <stdio.h>
#include <stdlib.h>



typedef struct aa
{
	char ime[50];
	float velicina;
	char eks[10];
	struct aa *levi,*desni;	
}drvo;



#define novi(x) x=(drvo*) malloc(sizeof(drvo));


void stampajdrvo(drvo *p)
{
	if(p)
	{
		stampajdrvo(p->desni);
		printf("Fajl: %s Velicina: %f Ekstenzija: %s\n",p->ime,p->velicina,p->eks);
		stampajdrvo(p->levi);		
	}
	
}


void dodaj(drvo **p,char ime[],float velicina,char eks[])
{
	drvo *temp;
	novi(temp);
	temp->levi=temp->desni=NULL;
	strcpy(temp->ime,ime);
	strcpy(temp->eks,eks);
	temp->velicina	= velicina;
	
	if((*p)==NULL) (*p)=temp;
	else
	{
		drvo *pom1,*pom2;
		
		pom1=(*p);
		
		while(pom1)
		{
			pom2=pom1;
			if(pom1->velicina>velicina) pom1=pom1->levi;
			else pom1=pom1->desni;
			
		}
		if(pom2->velicina>velicina) pom2->levi=temp;
			else pom2->desni=temp;
		
	}
	
}


drvo *ucitajdrvo(FILE *f)
{
	int n;
	drvo *p;
	p=NULL;
	float velicina;
	char ime[50];
	char eks[10];
	
	fscanf(f,"%d",&n);
	
	while(n--)
	{
		fscanf(f,"%s%f%s",ime,&velicina,eks);
		
		dodaj(&p,ime,velicina,eks);	
		
	}
	return p;
	
	
}

void napravninovodrvo(drvo *p,drvo **q,float velicina,char eks[])
{
	if(p)
	{
		if(p->velicina>velicina && !strcmp(eks,p->eks)) dodaj(q,p->ime,p->velicina,p->eks);
		if(p->levi ) napravninovodrvo(p->levi,q,velicina,eks);		
		if(p->desni) napravninovodrvo(p->desni,q,velicina,eks);		
	}
	
	
}

void napravninovodrvo2(drvo *p,drvo **q,float velicina,char eks[])
{
	if(p)
	{
		if(p->velicina<velicina)
		{
	
			napravninovodrvo2(p->desni,q,velicina,eks);
		}
		else
		{
		if(p->velicina>velicina && !strcmp(eks,p->eks)) dodaj(q,p->ime,p->velicina,p->eks);
		if(p->levi ) napravninovodrvo(p->levi,q,velicina,eks);		
		if(p->desni) napravninovodrvo(p->desni,q,velicina,eks);		
			
		}
	}
	
	
}





void main(int argc,char *argv[])
{
	FILE *f;
	f=fopen(argv[1],"r");
	drvo *p;
	p=ucitajdrvo(f);
	stampajdrvo(p);
	printf("Unesi ekstenziju i velicinu\n");
	float velicina;
	char eks[10];
	scanf("%s",eks);
	scanf("%f",&velicina);

	drvo *q;
	q=NULL;
	
	napravninovodrvo2(p,&q,velicina,eks);
	
	stampajdrvo(q);
	
	
	
}
	





