#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct drvo
{
	char naziv_fajla[20];
	float velicina_fajla;
	char ekstenzija[10];
	struct drvo *levi, *desni;
}drvo;

#define novi(x) x=(drvo*) malloc(sizeof(drvo))

void dodaj_drvo( drvo **p, char naziv_fajla[], float velicina_fajla, char ekstenzija[])
{
	drvo *temp, *pom1, *pom2;
	
	novi(temp);
	if(!temp)
	{
		printf("Losa alokacija\n");
		exit(0);
	}
	
	strcpy(temp->naziv_fajla,naziv_fajla);
	temp->velicina_fajla=velicina_fajla;
	strcpy(temp->ekstenzija,ekstenzija);
	
	if(*p==NULL) *p=temp;
	else
	{
		pom1=*p;
		while(pom1)
		{
			pom2=pom1;
			if(temp->velicina_fajla < pom1->velicina_fajla) pom1=pom1->levi;
			else pom1=pom1->desni;
		}
		
		if(temp->velicina_fajla < pom2->velicina_fajla) pom2->levi=temp;
		else pom2->desni=temp;
	}
}

drvo *formiraj_drvo( int n)
{
	drvo *p=NULL;
	char naziv_fajla[20];
	float velicina_fajla;
	char ekstenzija[10];
	
	int i;
	for(i=0; i<n; i++)
	{
		printf("Unesite naziv fajla\n");
		gets(naziv_fajla);
		printf("Unesite velicinu fajla\n");
		scanf("%f",&velicina_fajla); getchar();
		printf("Unesite ekstenziju\n");
		gets(ekstenzija);
		dodaj_drvo(&p,naziv_fajla,velicina_fajla,ekstenzija);
	}
	
	return p;
}

void ispisi_drvo( drvo *p)
{
	if(p)
	{
		ispisi_drvo(p->desni);
		printf("Ime fajla je %s,njegova velicina %f,a ekstenzija %s\n",p->naziv_fajla,p->velicina_fajla,p->ekstenzija);
		ispisi_drvo(p->levi);
	}
}

void novo_drvo( drvo *p, drvo **q, char ekstenzija[], int velicina_fajla)
{
	if(p)
	{
		if(!strcmp(p->ekstenzija,ekstenzija) && p->velicina_fajla > velicina_fajla)
			dodaj_drvo(q,p->naziv_fajla,p->velicina_fajla,p->ekstenzija);
		
		if(velicina_fajla > p->velicina_fajla) novo_drvo(p->desni,q,ekstenzija,velicina_fajla);
		else
		{
			novo_drvo(p->levi,q,ekstenzija,velicina_fajla);
			novo_drvo(p->desni,q,ekstenzija,velicina_fajla);
		}
	}
}

int main()
{
	drvo *p=NULL;
	int n; //broj elemenata
	printf("Unesite broj elemenata\n");
	scanf("%d",&n); getchar();
	p=formiraj_drvo(n);
	
	ispisi_drvo(p);
	
	char ekstenzija[30];
	int velicina_fajla;
	
	drvo *q=NULL; //novo drvo
	printf("Unesite ekstenziju fajla\n");
	gets(ekstenzija);
	printf("Unesite velicinu fajla\n");
	scanf("%d",&velicina_fajla);
	
	novo_drvo(p,&q,ekstenzija,velicina_fajla);
	
	ispisi_drvo(q);
	
	return 0;
}
	
		















	
