#include <stdio.h>
#include <stdlib.h>
#include <string.h>

struct fajl
{
	char naziv[50];
	int velicina;
	char ekstenzija[10];
	struct fajl *levi, *desni;
};

#define novi(x) x = (struct fajl*)malloc(sizeof(struct fajl))

void dodaj(struct fajl **p, char naziv[], int velicina, char ekstenzija[])
{
	struct fajl *pom, *juri, *kaska;
	
	novi(pom);
	if(!pom)
	{
		printf("Greksa pri alociranju.\n");
		exit(0);
	}
	
	strcpy(pom->naziv,naziv); strcpy(pom->ekstenzija,ekstenzija);
	pom->velicina = velicina;
	
	if(!(*p)) *p = pom;
	else
	{
		juri = *p;
		while(juri)
		{
			kaska = juri;
			if( velicina < juri->velicina) juri = juri->levi;
			else juri = juri->desni;
		}
		if( velicina < kaska->velicina ) kaska->levi = pom;
		else kaska->desni = pom;
	}
}

struct fajl *form(int n)
{
	struct fajl *p;
	char naziv[50],ekstenzija[10];
	int velicina,i;
	p = NULL;
	
	for(i = 0; i < n; i ++)
	{
		printf("Unesite ime fajla:\n");
		scanf("%s",naziv);
		printf("Unesite velicinu fajla:\n");
		scanf("%d",&velicina);
		printf("Unesite ekstenziju fajla:\n");
		scanf("%s",ekstenzija);
		dodaj(&p,naziv,velicina,ekstenzija);
		getchar();
	}
	return p;
}

void ispis(struct fajl *p)
{
	if(p)
	{
		ispis(p->desni);
		printf("%s %d %s\n",p->naziv,p->velicina,p->ekstenzija);
		ispis(p->levi);
	}
}
/*
void novo(struct fajl *p,int velicina,char ekstenzija[],struct fajl **q)
{
	if( p->levi ) novo(p->levi,velicina,ekstenzija,q);
	if( p->desni ) novo(p->desni,velicina,ekstenzija,q);
	
	if( (strcpm(p->ekstenzija,ekstenzija) == 0) && (p->velicina > velicina)) dodaj(q,p->naziv,velicina,ekstenzija);	
}
*/
int main()
{
	struct fajl *p;
	int n,velicina;
	char ekstenzija[50];
	printf("Unesite broj N:\n");
	scanf("%d",&n);
	p = form(n);
	ispis(p);
	/*
	struct fajl *q;
	printf("Unesite zeljenu ekstenziju:\n");
	scanf("%s",ekstenzija);
	printf("Unesite zeljenu velicina fajla:\n");
	scanf("%d",&velicina);
	q = NULL;
	novo(p,velicina,ekstenzija,&q);
	ispis(q);*/
	
	return 0;
}
