#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define novi(x) x=(struct drvo*)malloc(sizeof(struct drvo))

struct drvo {
	char *naziv;
	float velicina;
	char *ekstenzija;
	struct drvo *levi, *desni;
};

void dodaj(struct drvo **p,char *naziv, float velicina, char *ekstenzija)
{
	struct drvo *temp,*pom1,*pom2;
	novi(temp);
	temp->levi=temp->desni=NULL;
	temp->naziv=(char*)malloc(strlen(naziv)+1);
	strcpy(temp->naziv,naziv);
	temp->velicina=velicina;
	temp->ekstenzija=(char*)malloc(strlen(ekstenzija)+1);
	strcpy(temp->ekstenzija,ekstenzija);
	if((*p)==NULL) (*p)=temp;
	else
	{
		pom1=(*p);
		while(pom1)
		{
			pom2=pom1;
			if(temp->velicina < pom1->velicina) pom1=pom1->levi;
			else pom1=pom1->desni;
		}
		if(temp->velicina < pom2->velicina) pom2->levi=temp;
		else pom2->desni=temp;
	}
}

void ispis(struct drvo *p)
{
	if(p)
	{
		ispis(p->desni);
		printf("%s\t%f\t%s\n",p->naziv,p->velicina,p->ekstenzija);
		ispis(p->levi);
	}
}

void novo(struct drvo *p, struct drvo **q, char *eks, float vl)
{
	if(p->levi) novo(p->levi,&q,eks,vl);
	if(p->desni) novo(p->desni,&q,eks,vl);
	if((p->velicina > vl) && ((strcmp(p->ekstenzija,eks))==0)) 
	dodaj(&q,p->naziv,p->velicina,p->ekstenzija);
}

int main(void)
{
	struct drvo *p,*q;
	p=NULL;
	q=NULL;
	char naziv[100],ekstenzija[100], eks[100];
	float velicina, vl;
	int i,n;
	scanf("%d",&n);
	for(i=0;i<n;i++)
	{
		scanf("%s",&naziv);
		scanf("%f",&velicina);
		scanf("%s",&ekstenzija);
		dodaj(&p,naziv,velicina,ekstenzija);
	}
	ispis(p);
	scanf("%s",&eks);
	scanf("%f",&vl);
	novo(p,&q,eks,vl);
	ispis(q);
	return 0;
}
	
	
	
	
	
	
	
	
	
	
	
	
	
	
