#include<stdio.h>
#include<stdlib.h>
#include<string.h>

struct fajl
{
	char naziv[80];
	float velicina;
	char ekstenzija[80];
	struct fajl *levo;
	struct fajl *desno;
};

struct fajl* unos(FILE *f)
{
	struct fajl *vrh,*pom,*novi;
	vrh=NULL;
	char linija[80];
	int n;
	fgets(linija,80,f);
	sscanf(linija,"%d",&n);
	while(n>0)
	{
		novi=(struct fajl*)malloc(sizeof(struct fajl));
		fgets(linija,80,f);
		linija[strlen(linija)-1]='\0';
		strcpy(novi->naziv,linija);
		fgets(linija,80,f);
		sscanf(linija,"%f",&novi->velicina);
		fgets(linija,80,f);
		linija[strlen(linija)-1]='\0';
		strcpy(novi->ekstenzija,linija);
		novi->levo=NULL;
		novi->desno=NULL;
		if(vrh==NULL)
		{
			vrh=novi;
		}
		else
		{
			pom=vrh;
			while(pom!=novi)
			{
				if(pom->velicina<novi->velicina)
				{
					if(pom->levo==NULL) pom->levo=novi;
					pom=pom->levo;
				}
				else
				{
					if(pom->desno==NULL) pom->desno=novi;
					pom=pom->desno;
				}
			}
		}
		n--;
	}
	return vrh;
}

void ispis(struct fajl *vrh)
{
	if(vrh->desno==NULL) return;
	if(vrh->desno!=NULL) 
	ispis(vrh->desno);
	printf("%s %4.2f %s\n",vrh->naziv,vrh->velicina,vrh->ekstenzija);
	ispis(vrh->levo);
}

main(int argc,char* argv[])
{
	struct fajl *vrh;
	vrh=NULL;
	FILE *f;
	f=fopen(argv[1],"r");
	vrh=unos(f);
	ispis(vrh);
}
