#include<stdio.h>
#include<stdlib.h>
#include<string.h>

struct stajaliste
{
	char naziv[80];
	int ulaz;
	struct stajaliste *sledeci;
};

struct stajaliste* unos(FILE *f)
{
	struct stajaliste *poc,*pom,*novi;
	char linija[80],naziv[80];
	int n,ulaz,izlaz,trenutno=0,prethodno=0;
	poc=NULL;
	fgets(linija,80,f);
	sscanf(linija,"%d",&n);
	while(n>0)
	{
		fgets(naziv,80,f);
		naziv[strlen(naziv)-1]='\0';
		fgets(linija,80,f);
		sscanf(linija,"%d",&ulaz);
		fgets(linija,80,f);
		sscanf(linija,"%d",&izlaz);
		novi=(struct stajaliste*)malloc(sizeof(struct stajaliste));
		strcpy(novi->naziv,naziv);
		trenutno=prethodno+(ulaz-izlaz);
		if(trenutno>0)
		novi->ulaz=trenutno;
		else novi->ulaz=0;
		prethodno=novi->ulaz;
		if(poc==NULL)
		{
			poc=novi;
			novi->sledeci=poc;
		}
		else
		{
			pom=poc;
			while(pom->sledeci!=poc) pom=pom->sledeci;
			pom->sledeci=novi;
			novi->sledeci=poc;
		}
	n--;
	}
	return poc;
}

void ispis(struct stajaliste *poc)
{
	struct stajaliste *pom;
	printf("%s %4d\n",poc->naziv,poc->ulaz);
	pom=poc;
	pom=pom->sledeci;
	while(pom!=poc)
	{
		printf("%s %4d\n",pom->naziv,pom->ulaz);
		pom=pom->sledeci;
	}
}

main(int argc,char* argv[])
{
	struct stajaliste *poc;
	poc=NULL;
	FILE *f;
	f=fopen(argv[1],"r");
	poc=unos(f);
	ispis(poc);
}
