#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct fajl{
	char *naziv;
	float velicina;
	char *ekst;
	struct fajl *levi,*desni;
}FAJL;

#define aloc(x) x=(FAJL*)malloc(sizeof(FAJL))

void dodaj(FAJL **p,char nazivv[],float velicinaa,char ekstt[]){
	FAJL *novi,*pom1,*pom2;
	aloc(novi);
		if(!novi){
			printf("Greska u alokaciji!\n");
			exit(0);
		}
		novi->naziv=(char*)malloc(sizeof(nazivv)+1);
		strcpy(novi->naziv,nazivv);
		novi->velicina=velicinaa;
		novi->ekst=(char*)malloc(sizeof(ekstt)+1);
		strcpy(novi->ekst,ekstt);
		
		novi->levi=novi->desni=NULL;
		
		if((*p)==NULL) *p=novi;
		else{
			pom1=*p;
			while(pom1){
				pom2=pom1;
				if(velicinaa > pom1->velicina) pom1=pom1->desni;
				else pom1=pom1->levi;
			}
			if(velicinaa > pom2->velicina) pom2->desni=novi;
			else pom2->levi=novi;
		}
}

void form(FAJL **p,FILE *f){
	char nazivv[100];
	float velicinaa;
	char ekstt[100];
	int n,i;
	
	fscanf(f,"%d",&n);
	for (i = 0; i < n; i++)
	{
		fgets(nazivv,100,f);
		//nazivv[strlen(naziv)-1]='\0';
		fscanf(f,"%f",&velicinaa);
		fgets(ekstt,100,f);
		
		dodaj(p,nazivv,velicinaa,ekstt);
	}
}

void ispis(FAJL *p){
	if(p){
		if(p->levi) ispis(p->levi);
		printf("%s\n",p->naziv);
		printf("%f\n",p->velicina);
		printf("%s\n",p->ekst);
		if(p->desni) ispis(p->desni);
	}
}

void ispis2(FAJL *p){
	if(p){
		if(p->levi) ispis(p->levi);
		printf("%s",p->naziv);
		printf("%f\n",p->velicina);
		printf("%s",p->ekst);
		if(p->desni) ispis(p->desni);
	}
}

/*void ispitaj(FAJL *p,char *EKS,float VL){
	FILE *f;
	if(p->levi) ispitaj(p,EKS,VL);
		if((strcmp(p->ekst,EKS)==0) && (p->velicina > VL)) {
			form(&p,f);
			ispis2(p);
		}
	if(p->levi) ispitaj(p,EKS,VL);
	
}*/

int main(int argc,char *argv[]){
	FILE *f=fopen(argv[1],"r");
	FAJL *p=NULL;
	char *EKS;
	float VL;
	form(&p,f);
	ispis(p);
	//gets(EKS);
	//scanf("%f",&VL);
	//ispitaj(p,EKS,VL);
}
















