#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct tramvaj{
	char *naziv;
	int broj;
	struct tramvaj *sledeci;
}TRAMVAJ;

#define aloc(x) x=(TRAMVAJ*)malloc(sizeof(TRAMVAJ))

void dodaj(TRAMVAJ **p,char *nazivv,int brojj){
	TRAMVAJ *novi,*pom;
	aloc(novi);
	if(!novi){
		printf("Greska u alociranju!\n");
		exit(0);
	}
	
	novi->naziv=(char*)malloc(sizeof(nazivv)+1);
	strcpy(novi->naziv,nazivv);
	novi->broj=brojj;
	
	if(*p==NULL){ 
		*p=novi;
		novi->sledeci=*p;
	}
	else{
		pom=*p;
		while(pom->sledeci != (*p)){
			pom=pom->sledeci;
		}
		pom->sledeci=novi;
		novi->sledeci=*p;
	}
}

void form(TRAMVAJ **p,FILE *f){
	char nazivv[100];
	int brojj=0,uulaz,iizlaz;
	int n,i;
	
	fscanf(f,"%d",&n);
	for (i = 0; i < n; i++)
	{
		fgets(nazivv,100,f);
		fscanf(f,"%d",&uulaz);
		fscanf(f,"%d",&iizlaz);
		brojj+=uulaz+iizlaz;
		dodaj(p,nazivv,brojj);
	}
	
}

void ispis(TRAMVAJ *p){
	TRAMVAJ *pom;
	pom=p;
	while(pom->sledeci != p){
		printf("%s",p->naziv);
		printf("%d\n",p->broj);
		pom=pom->sledeci;
	}
}

int main(int argc,char *argv[]){
	FILE *f=fopen(argv[1],"r");
	TRAMVAJ *p=NULL;
	form(&p,f);
	ispis(p);
}


