#include <stdio.h>
#include <string.h>
#include <stdlib.h>

struct fajl
{
	char *naziv;
	float velicina;
	char *ekstenzija;
	struct fajl *levi, *desni;
};

#define novi_str(x,n) x=(char *)malloc(n*sizeof(char))
#define novi(x) x=(struct fajl *)malloc(sizeof(struct fajl))

void dodaj(struct fajl **, struct fajl *);
struct fajl *formiraj(void);
void ispisi(struct fajl *);
void formiraj_novi(struct fajl **, struct fajl *, char *, float);
int main(void)
{
	struct fajl *koren;
	koren=formiraj();
	ispisi(koren);
	char eks[30];
	float vl;
	scanf("%s",eks);
	scanf("%f",&vl);
	struct fajl *novikoren=NULL;
	printf("------------------------------\n");
	printf("EKSTENZIJA %s i VEL %f\n",eks,vl);
	formiraj_novi(&novikoren,koren,eks,vl);
	ispisi(novikoren);
	return 0;
}

void dodaj(struct fajl **koren, struct fajl *dod)
{
	struct fajl *pom1, *pom2;
	if (!(*koren))
		*koren=dod;
	else
	{
		pom1=*koren;
		while (pom1)
		{
			pom2=pom1;
			if (dod->velicina<pom1->velicina)
				pom1=pom1->levi;
			else
				pom1=pom1->desni;
		}
		if (dod->velicina<pom2->velicina)
			pom2->levi=dod;
		else
			pom2->desni=dod;
	}
}
struct fajl *formiraj(void)
{
	struct fajl *koren=NULL, *temp;
	int n;
	char str[100];
	for (scanf("%d",&n), getchar(); n ; n--)
	{
		novi(temp);
		scanf("%s",str);
		novi_str(temp->naziv,strlen(str)+1);
		strcpy(temp->naziv,str);
		scanf("%f",&temp->velicina);
		getchar();
		scanf("%s",str);
		novi_str(temp->ekstenzija,strlen(str)+1);
		strcpy(temp->ekstenzija,str);
		temp->levi=NULL;
		temp->desni=NULL;
		dodaj(&koren,temp);
	}
	return koren;
}
void ispisi(struct fajl *koren)
{
	if (koren)
	{
		ispisi(koren->desni);
		printf("%s - %f - %s\n",koren->naziv,koren->velicina,koren->ekstenzija);
		ispisi(koren->levi);
	}
}
void formiraj_novi(struct fajl **novikoren, struct fajl *koren, char *eks, float vl)
{
	struct fajl *temp;
	if (koren)
	{
		if (!strcmp(koren->naziv,eks) && koren->velicina>vl)
		{
			novi(temp);
			novi_str(temp->naziv,strlen(koren->naziv)+1);
			strcpy(temp->naziv,koren->naziv);
			temp->velicina=vl;
			novi_str(temp->ekstenzija,strlen(eks)+1);
			strcpy(temp->ekstenzija,eks);
			dodaj(novikoren,temp);
		}
		formiraj_novi(novikoren,koren->levi,eks,vl);
		formiraj_novi(novikoren,koren->desni,eks,vl);
	}	
}
